#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"io.h"

#include	"ureg.h"

void
delay(int ms)
{
	int i;

	ms *= 13334;		/* experimentally indetermined */
	for(i=0; i<ms; i++)
		;
}

typedef struct Ctr Ctr;
struct Ctr
{
	ulong	lim;
	ulong	ctr;
	ulong	limnr;	/* non-resetting */
	ulong	ctl;
};
Ctr	*ctr;

void
clockinit(void)
{
	KMap *k;

	putphys(TIMECONFIG, 0);	/* it's a processor counter */
	k = kmappa(CLOCK, PTENOCACHE|PTEIO);
	ctr = (Ctr*)VA(k);
	ctr->lim = (CLOCKFREQ/HZ)<<10;
}

void
clock(Ureg *ur)
{
	Proc *p;
	ulong i, nrun = 0;

	i = ctr->lim;	/* clear interrupt */
	USED(i);
	ctr->lim = (CLOCKFREQ/HZ)<<10;	/* is this needed? page 6-43 801-3137-10 suggests so */
	m->ticks++;
	p = m->proc;
	if(p){
		nrun = 1;
		p->pc = ur->pc;
		if (p->state==Running)
			p->time[p->insyscall]++;
	}
	nrun = (nrdy+nrun)*1000;
	MACHP(0)->load = (MACHP(0)->load*19+nrun)/20;

	checkalarms();
	kbdclock();
	mouseclock();
	sccclock();
	kproftimer(ur->pc);
	if(m->fpunsafe)
		return;

	if((ur->psr&SPL(0xF))==0 && p && p->state==Running) {
		if(anyready()){
			if(p->hasspin)
				p->hasspin = 0;
			else
				sched();
		}
		if((ur->psr&PSRPSUPER) == 0)
			*(ulong*)(USTKTOP-BY2WD) += TK2MS(1);
	}
}
